searchNodes=[{"doc":"Decodes and encodes logfmt-style log lines. In logfmt -style log lines, data is encoded as a string of &quot;key-value&quot; pairs. Logfmt can encode a Dict into a string in this format, provided that its value types are String.t , number , and boolean . It will decode a line in this format into a map, and attempt to coerce numbers and booleans into integers, floats, and booleans.","ref":"Logfmt.html","title":"Logfmt","type":"module"},{"doc":"Decodes the given line into a map. Examples iex&gt; Logfmt . decode &quot;foo=bar baz=qux&quot; %{ &quot;foo&quot; =&gt; &quot;bar&quot; , &quot;baz&quot; =&gt; &quot;qux&quot; } iex&gt; Logfmt . decode ~s(foo=&quot;bar baz&quot;) %{ &quot;foo&quot; =&gt; &quot;bar baz&quot; } iex&gt; Logfmt . decode &quot;foo=true&quot; %{ &quot;foo&quot; =&gt; true } iex&gt; Logfmt . decode &quot;foo=1&quot; %{ &quot;foo&quot; =&gt; 1 }","ref":"Logfmt.html#decode/1","title":"Logfmt.decode/1","type":"function"},{"doc":"Encodes the given Dict into a Logfmt-style line. Optionally a list of options can be given to change the encode behaviour. Options output - if set to :iolist , an iolist is returned, any other value will return a binary Examples iex&gt; Logfmt . encode [ foo : &quot;bar&quot; ] &quot;foo=bar&quot; iex&gt; Logfmt . encode %{ &quot;foo&quot; =&gt; &quot;bar&quot; } &quot;foo=bar&quot; iex&gt; Logfmt . encode [ foo : &quot;bar baz&quot; ] &quot;foo= \\&quot; bar baz \\&quot; &quot; iex&gt; Logfmt . encode [ foo : &quot;bar baz&quot; ] , [ output : :iolist ] [ [ &quot;foo&quot; , &quot;=&quot; , [ &quot; \\&quot; &quot; , &quot;bar baz&quot; , &quot; \\&quot; &quot; ] ] ]","ref":"Logfmt.html#encode/2","title":"Logfmt.encode/2","type":"function"},{"doc":"Decodes a logfmt-style log line into a map . Examples iex&gt; Logfmt . decode &quot;foo=bar&quot; %{ &quot;foo&quot; =&gt; &quot;bar&quot; } iex&gt; Logfmt . decode &quot;foo=true&quot; %{ &quot;foo&quot; =&gt; true }","ref":"Logfmt.Decoder.html","title":"Logfmt.Decoder","type":"module"},{"doc":"See Logfmt.decode .","ref":"Logfmt.Decoder.html#decode/1","title":"Logfmt.Decoder.decode/1","type":"function"},{"doc":"Encode a Dict into a logfmt-style log line. Examples iex&gt; Logfmt . encode [ foo : &quot;bar&quot; ] &quot;foo=bar&quot; iex&gt; Logfmt . encode [ foo : &quot;bar baz&quot; , qux : true ] &quot;foo= \\&quot; bar baz \\&quot; qux=true&quot;","ref":"Logfmt.Encoder.html","title":"Logfmt.Encoder","type":"module"},{"doc":"See Logfmt.encode .","ref":"Logfmt.Encoder.html#encode/2","title":"Logfmt.Encoder.encode/2","type":"function"},{"doc":"","ref":"Logfmt.ValueEncoder.html","title":"Logfmt.ValueEncoder","type":"protocol"},{"doc":"","ref":"Logfmt.ValueEncoder.html#encode/1","title":"Logfmt.ValueEncoder.encode/1","type":"function"},{"doc":"","ref":"Logfmt.ValueEncoder.html#t:t/0","title":"Logfmt.ValueEncoder.t/0","type":"type"},{"doc":"The MIT License (MIT) Copyright (c) 2015 Jonathan Clem Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"Logfmt Logfmt is a module for encoding and decoding logfmt-style log lines.","ref":"readme.html","title":"Readme","type":"extras"},{"doc":"The package can be installed by adding :logfmt to your list of dependencies in mix.exs : def deps do [ { :logfmt , &quot;~&gt; 3.3&quot; } ] end","ref":"readme.html#installation","title":"Readme - Installation","type":"extras"},{"doc":"Decode log lines into maps: iex&gt; Logfmt . decode &quot;foo=bar&quot; %{ &quot;foo&quot; =&gt; &quot;bar&quot; } Encode Dict implementation values into log lines: iex&gt; Logfmt . encode [ foo : &quot;bar&quot; ] &quot;foo=bar&quot; iex&gt; Logfmt . encode %{ foo : &quot;bar&quot; } &quot;foo=bar&quot; Custom types can encoded by implementing the ValueEncoder protocol for it. For example to encode DateTime and NaiveDateTime and implementation could look like this: defimpl Logfmt.ValueEncoder , for : NaiveDateTime do def encode ( naive_date_time ) , do : NaiveDateTime . to_iso8601 ( naive_date_time ) end defimpl Logfmt.ValueEncoder , for : DateTime do def encode ( date_time ) , do : DateTime . to_iso8601 ( date_time ) end","ref":"readme.html#usages","title":"Readme - Usages","type":"extras"},{"doc":"When decoding a log line, Logfmt will coerce some strings into booleans and numbers: iex&gt; Logfmt . decode &quot;foo=true&quot; %{ &quot;foo&quot; =&gt; true } iex&gt; Logfmt . decode &quot;foo=-1.2e9&quot; %{ &quot;foo&quot; =&gt; - 1.2e9 } In the future, this may be optional, or more robust. For example, it might make sense for &quot;foo=true&quot; to decode into %{&quot;foo&quot; =&gt; true} , but ~s(foo=&quot;true&quot;) to decode into %{&quot;foo&quot; =&gt; &quot;true&quot;} . Another option might be to allow the user to provide a formatting map to the decode function, which expects coercion functions as values: iex&gt; &quot;foo=1 bar=2&quot; |&gt; Logfmt . decode %{ ...&gt; foo : &amp; Logfmt.TypeCoercion . parse_integer / 1 ...&gt; } %{ &quot;foo&quot; =&gt; 1 , &quot;bar&quot; =&gt; &quot;2&quot; }","ref":"readme.html#type-coercion","title":"Readme - Type Coercion","type":"extras"},{"doc":"Originally, this library both decoded and encoded maps. However, this was problematic because key ordering in maps is not guaranteed. A developer wants to be able to ensure that their log output will have identical ordering for multiple calls for the sake of readability. To solve this, the second version encoded and decoded Keyword lists only. Of course, this is also problematic because decoding log lines into Keyword lists involves converting user strings into non-garbage-collected atoms. Now, this module decodes into maps only (with string keys) and encodes any Dict implementation type. This is a fair compromise, because ordering upon decoding a Logfmt line is not important, and keeping only the last value for a duplicate key in a log line is fair, as well.","ref":"readme.html#why-decode-into-maps","title":"Readme - Why decode into maps?","type":"extras"}]